(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     13729,        449]
NotebookOptionsPosition[     12506,        405]
NotebookOutlinePosition[     12966,        423]
CellTagsIndexPosition[     12923,        420]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["Comments on Math Horizons Playground Problem #241 \
(Feb. 2010)",
 FontWeight->"Bold"]], "Text",
 Background->GrayLevel[0.85]],

Cell["\<\
Stan Wagon
Macalester College, St Paul, MN\
\>", "Text"],

Cell[TextData[{
 "The assertion that ",
 Cell[BoxData[
  FormBox["a", TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", ",
 Cell[BoxData[
  FormBox["b", TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", ",
 Cell[BoxData[
  FormBox["c", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " are nonnegative is not necessary. The empty set is returned when we look \
for a counterexample and forget about the sign condition. ",
 Cell[BoxData["FindInstance"]],
 " uses algebraic algorithms that provide symbolic proof (though there is no \
certification method, as there is with, say, integrals)."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindInstance", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox["a", "4"], " ", 
      RowBox[{"(", 
       RowBox[{"a", "-", "b"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"a", "-", "c"}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["b", "4"], " ", 
      RowBox[{"(", 
       RowBox[{"b", "-", "a"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"b", "-", "c"}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["c", "4"], " ", 
      RowBox[{"(", 
       RowBox[{"c", "-", "a"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"c", "-", "b"}], ")"}]}]}], "<", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "-", "b"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"b", "-", "c"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"c", "-", "a"}], ")"}]}], ")"}], "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.477080306691675*^9, 3.477080310864635*^9}}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.47708031251131*^9}]
}, Open  ]],

Cell["So this solves #241 as stated. Now on to the challenge.", "Text",
 CellChangeTimes->{{3.47709381963272*^9, 3.477093827974292*^9}}],

Cell[TextData[{
 "Using the nonnegativity condition one finds that the result is true for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"k", "=", "1"}], TraditionalForm]]],
 ", 2, 3, 4 and 5. But for ",
 Cell[BoxData[
  FormBox[
   RowBox[{"k", "=", "6"}], TraditionalForm]]],
 " there is a counterexample ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", "5"], ",", 
     FractionBox["1", "36"], ",", "1"}], ")"}], TraditionalForm]]],
 ", and so the answer to the question is 5 if we are thinking that ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " must be in integer."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindInstance", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
    RowBox[{"b", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
    RowBox[{"c", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["a", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"a", "-", "b"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"a", "-", "c"}], ")"}]}], "+", 
      RowBox[{
       SuperscriptBox["b", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"b", "-", "a"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"b", "-", "c"}], ")"}]}], "+", 
      RowBox[{
       SuperscriptBox["c", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"c", "-", "a"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"c", "-", "b"}], ")"}]}]}], "<", 
     RowBox[{"6", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "-", "b"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"b", "-", "c"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "-", "a"}], ")"}]}], ")"}], "2"]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.477080306691675*^9, 3.477080310864635*^9}, {
  3.477080341682023*^9, 3.4770803809274273`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", 
     FractionBox["4", "5"]}], ",", 
    RowBox[{"b", "\[Rule]", 
     FractionBox["1", "36"]}], ",", 
    RowBox[{"c", "\[Rule]", "1"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.477080358685583*^9, 3.477080382261162*^9}}]
}, Open  ]],

Cell["\<\
Now a little more work shows that there are counterexamples for small values \
greater than 5. \
\>", "Text",
 CellChangeTimes->{{3.477080621237661*^9, 3.477080636002489*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindInstance", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
    RowBox[{"b", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
    RowBox[{"c", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["a", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"a", "-", "b"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"a", "-", "c"}], ")"}]}], "+", 
      RowBox[{
       SuperscriptBox["b", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"b", "-", "a"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"b", "-", "c"}], ")"}]}], "+", 
      RowBox[{
       SuperscriptBox["c", "4"], " ", 
       RowBox[{"(", 
        RowBox[{"c", "-", "a"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"c", "-", "b"}], ")"}]}]}], "<", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"5", "+", 
        RowBox[{"1", "/", "1000"}]}], " ", ")"}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "-", "b"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"b", "-", "c"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "-", "a"}], ")"}]}], ")"}], "2"]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.477080306691675*^9, 3.477080310864635*^9}, {
  3.477080341682023*^9, 3.4770803809274273`*^9}, {3.477080539369965*^9, 
  3.477080609726282*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", 
     FractionBox["17653", "17654"]}], ",", 
    RowBox[{"b", "\[Rule]", 
     FractionBox["217", "3472712"]}], ",", 
    RowBox[{"c", "\[Rule]", "1"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.477080550295392*^9, 3.477080612329425*^9}}]
}, Open  ]],

Cell[TextData[{
 "So it appears that 5 is the largest real number for which this is true. ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " has functions that can decide certain polynomial assertions over the real \
numbers. Let's try ",
 Cell[BoxData["Resolve"]],
 " to resolve the set of ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " for which there is a counterexample. We can use the logical functions ",
 Cell[BoxData["ForAll"]],
 " and ",
 Cell[BoxData["Implies"]],
 "."
}], "Text",
 CellChangeTimes->{{3.4770938543975477`*^9, 3.47709386523025*^9}, {
  3.477094051454726*^9, 3.477094080157483*^9}, {3.4770947854222183`*^9, 
  3.477094815464522*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Resolve", "[", " ", 
   RowBox[{
    RowBox[{"ForAll", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
      RowBox[{"Implies", "[", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"a", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
         RowBox[{"b", "\[GreaterEqual]", "0"}], " ", "&&", " ", 
         RowBox[{"c", "\[GreaterEqual]", "0"}]}], ",", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox["a", "4"], " ", 
           RowBox[{"(", 
            RowBox[{"a", "-", "b"}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"a", "-", "c"}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["b", "4"], " ", 
           RowBox[{"(", 
            RowBox[{"b", "-", "a"}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"b", "-", "c"}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["c", "4"], " ", 
           RowBox[{"(", 
            RowBox[{"c", "-", "a"}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"c", "-", "b"}], ")"}]}]}], "\[GreaterEqual]", 
         RowBox[{"k", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"a", "-", "b"}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"b", "-", "c"}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"c", "-", "a"}], ")"}]}], ")"}], "2"]}]}]}], "]"}]}], 
     "]"}], ",", " ", "Reals"}], "]"}], " ", "//", "Timing"}]], "Input",
 CellChangeTimes->{{3.477093994535111*^9, 3.477094044044001*^9}, {
  3.477094086813114*^9, 3.4770941242008753`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"106.41145199999994`", ",", 
   RowBox[{"k", "\[LessEqual]", "5"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4770940415985928`*^9, 3.4770940846964207`*^9, 
  3.477094233952833*^9}]
}, Open  ]],

Cell["Here it is in nicer logical form.", "Text",
 CellChangeTimes->{{3.4770948388467007`*^9, 3.4770948491184053`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Resolve", "[", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[ForAll]", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c"}], "}"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "\[GreaterEqual]", "0"}], "&&", 
        RowBox[{"b", "\[GreaterEqual]", "0"}], "&&", 
        RowBox[{"c", "\[GreaterEqual]", "0"}]}], "\[Implies]", 
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox["a", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"a", "-", "b"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "-", "c"}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["b", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"b", "-", "a"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"b", "-", "c"}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["c", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"c", "-", "a"}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "-", "b"}], ")"}]}]}], "\[GreaterEqual]", 
        RowBox[{"k", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"a", "-", "b"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"b", "-", "c"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"c", "-", "a"}], ")"}]}], ")"}], "2"]}]}]}], ")"}]}], 
    ",", "Reals"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.477093994535111*^9, 3.477094044044001*^9}, {
   3.477094086813114*^9, 3.4770941242008753`*^9}, 3.477094821983018*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"106.41145199999994`", ",", 
   RowBox[{"k", "\[LessEqual]", "5"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4770940415985928`*^9, 3.4770940846964207`*^9, 
  3.477094233952833*^9}]
}, Open  ]],

Cell[TextData[{
 "Lovely!!  It takes two minutes, but this tells us -- it ",
 StyleBox["proves",
  FontSlant->"Italic"],
 " it using well understood algebraic algorithms -- that the set of ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " that work is exactly the set of ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "\[Infinity]"}], "<", "k", "\[LessEqual]", "5"}], 
   TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Text",
 CellChangeTimes->{{3.477094663105077*^9, 3.477094746416191*^9}, {
  3.477094827976367*^9, 3.477094833656439*^9}}]
},
WindowSize->{979, 690},
WindowMargins->{{64, Automatic}, {Automatic, 80}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 150, 3, 63, "Text"],
Cell[698, 25, 66, 3, 66, "Text"],
Cell[767, 30, 622, 18, 84, "Text"],
Cell[CellGroupData[{
Cell[1414, 52, 1059, 34, 80, "Input"],
Cell[2476, 88, 86, 2, 40, "Output"]
}, Open  ]],
Cell[2577, 93, 136, 1, 39, "Text"],
Cell[2716, 96, 649, 21, 78, "Text"],
Cell[CellGroupData[{
Cell[3390, 121, 1363, 40, 103, "Input"],
Cell[4756, 163, 315, 9, 64, "Output"]
}, Open  ]],
Cell[5086, 175, 185, 4, 39, "Text"],
Cell[CellGroupData[{
Cell[5296, 183, 1499, 44, 105, "Input"],
Cell[6798, 229, 330, 9, 64, "Output"]
}, Open  ]],
Cell[7143, 241, 703, 19, 84, "Text"],
Cell[CellGroupData[{
Cell[7871, 264, 1684, 46, 105, "Input"],
Cell[9558, 312, 219, 5, 40, "Output"]
}, Open  ]],
Cell[9792, 320, 119, 1, 39, "Text"],
Cell[CellGroupData[{
Cell[9936, 325, 1624, 46, 163, "Input"],
Cell[11563, 373, 219, 5, 40, "Output"]
}, Open  ]],
Cell[11797, 381, 705, 22, 62, "Text"]
}
]
*)

(* End of internal cache information *)
